package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.collect.UnmodifiableIterator;
import com.mojang.blaze3d.vertex.PoseStack;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import java.util.Objects;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.Font;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.screens.inventory.tooltip.ClientTooltipComponent;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.resources.ResourceLocation;
import org.joml.Matrix4f;

public class SocketTooltipRenderer implements ClientTooltipComponent {
  public static final ResourceLocation SOCKET = new ResourceLocation("apotheosis", "textures/gui/socket.png");
  
  private final SocketComponent comp;
  
  private final int spacing;
  
  public SocketTooltipRenderer(SocketComponent comp) {
    Objects.requireNonNull((Minecraft.m_91087_()).f_91062_);
    this.spacing = 9 + 2;
    this.comp = comp;
  }
  
  public int m_142103_() {
    return this.spacing * this.comp.gems.size();
  }
  
  public int m_142069_(Font font) {
    int maxWidth = 0;
    for (UnmodifiableIterator<GemInstance> unmodifiableIterator = this.comp.gems.gems().iterator(); unmodifiableIterator.hasNext(); ) {
      GemInstance inst = unmodifiableIterator.next();
      maxWidth = Math.max(maxWidth, font.m_92852_((FormattedText)getSocketDesc(inst)) + 12);
    } 
    return maxWidth;
  }
  
  public void m_183452_(Font font, int x, int y, GuiGraphics gfx) {
    for (int i = 0; i < this.comp.gems.size(); i++)
      gfx.m_280398_(SOCKET, x, y + this.spacing * i, 0, 0.0F, 0.0F, 9, 9, 9, 9); 
    for (GemInstance inst : this.comp.gems()) {
      if (inst.isValid()) {
        PoseStack pose = gfx.m_280168_();
        pose.m_85836_();
        pose.m_85841_(0.5F, 0.5F, 1.0F);
        gfx.m_280203_(inst.gemStack(), 2 * x + 1, 2 * y + 1);
        pose.m_85849_();
      } 
      y += this.spacing;
    } 
  }
  
  public void m_142440_(Font pFont, int pX, int pY, Matrix4f pMatrix4f, MultiBufferSource.BufferSource pBufferSource) {
    for (int i = 0; i < this.comp.gems.size(); i++)
      pFont.m_272077_(getSocketDesc(this.comp.gems.get(i)), (pX + 12), (pY + 1 + this.spacing * i), 11189196, true, pMatrix4f, (MultiBufferSource)pBufferSource, Font.DisplayMode.NORMAL, 0, 15728880); 
  }
  
  public static Component getSocketDesc(GemInstance inst) {
    if (!inst.isValid())
      return (Component)Component.m_237115_("socket.apotheosis.empty"); 
    return inst.getSocketBonusTooltip();
  }
}
